uniform mat4 modelViewMatrix;
uniform mat4 projectionMatrix;
uniform mat3 normalMatrix;

attribute vec3 position;
attribute vec3 normal;
attribute vec4 boneIds;
attribute vec4 weights;

varying vec4 fragVertex;
varying vec3 fragNormal;

#define MAX_BONES 100

uniform mat4 bone[MAX_BONES];

void main() {
	mat4 boneTransform = bone[int(boneIds.r)] * weights.r;
    boneTransform     += bone[int(boneIds.g)] * weights.g;
    boneTransform     += bone[int(boneIds.b)] * weights.b;
    boneTransform     += bone[int(boneIds.a)] * weights.a;

    fragVertex = modelViewMatrix * boneTransform * vec4(position, 1.0);
    gl_Position = projectionMatrix * fragVertex;
    fragNormal = normalMatrix * normal;
}


