
(function(l, r) { if (l.getElementById('livereloadscript')) return; r = l.createElement('script'); r.async = 1; r.src = '//' + (window.location.host || 'localhost').split(':')[0] + ':35729/livereload.js?snipver=1'; r.id = 'livereloadscript'; l.head.appendChild(r) })(window.document);
'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var log = (function (str) {
    if (window.jsLog) {
        window.jsLog(str);
    }
});
//# sourceMappingURL=log.js.map

/**
 * @description
 * @author chenjun
 * @export
 * @class JsBridge
 * @implements {bridgeInterface}
 */
var JsBridge = /** @class */ (function () {
    function JsBridge() {
        this.bridge = {};
        this.isClient = !!window.jsCallback;
        this.init();
    }
    JsBridge.prototype.init = function () {
        window.bridge = this.bridge;
    };
    JsBridge.prototype.send = function (params) {
        if (params === void 0) { params = ''; }
        if (this.isClient) {
            try {
                var data = typeof params === 'string'
                    ? params
                    : JSON.stringify(params);
                // window.webkit.messageHandlers.jsCallback.postMessage(data)
                // ios 统一使用ui webview
                window.jsCallback.onResponse(data);
                console.log({ params: params });
                log(data);
            }
            catch (e) {
                console.log(e);
                log(e.toString());
            }
        }
        else {
            console.log('不在客户端环境内', JSON.stringify(params));
        }
    };
    JsBridge.prototype.register = function (eventName, callback) {
        this.bridge[eventName] = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            callback.apply(void 0, args);
        };
    };
    return JsBridge;
}());
//# sourceMappingURL=js-bridge.js.map

/**
 * @description
 * @author chenjun
 * @export
 * @param {string} tagName
 * @returns {HTMLElement}
 */
function createElement(tagName) {
    return document.createElement(tagName);
}
function isUndefined(o) {
    return typeof o === 'undefined';
}
/**
 * @description
 * @author chenjun
 * @export
 * @param {HTMLElement} el
 * @param {{ [key: string]: any }} styles
 */
function setStyle(el, styles) {
    var numberStyleTypes = ["zIndex", "opacity"];
    for (var i in styles) {
        if (isUndefined(styles[i]))
            continue;
        el.style[i] =
            typeof styles[i] === "number" && !numberStyleTypes.includes(i)
                ? styles[i] + "px"
                : styles[i];
    }
}
// TODO: use cssText
// /**
//  * @description
//  * @author chenjun
//  * @param {{ [key: string]: any }} styles
//  * @returns {string}
//  */
// function mergeStyleToText(styles: { [key: string]: any }): string {
//     const numberStyleTypes = ['zIndex', 'opacity'];
//     let result = [];
//     for (const i in styles) {
//         if (isUndefined(styles[i])) continue;
//         const styleName = i.replace(/[A-Z]/g, word => `-${word.toLowerCase()}`);
//         const value =
//             typeof styles[i] === 'number' && !numberStyleTypes.includes(i)
//                 ? styles[i] + 'px'
//                 : styles[i];
//         result.push(`${styleName}="${value}"`);
//     }
//     return result.join(';');
// }
// /**
//  * @description
//  * @author chenjun
//  * @export
//  * @param {HTMLElement} el
//  * @param {{ [key: string]: any }} styles
//  * @returns {void}
//  */
// export function setStyle(
//     el: HTMLElement,
//     styles: { [key: string]: any }
// ): void {
//     const numberStyleTypes = ['zIndex', 'opacity'];
//     const oldCssText: string = el.style.cssText;
//     console.log( mergeStyleToText(styles))
//     el.style.cssText = oldCssText + ';' + mergeStyleToText(styles);
// }
//# sourceMappingURL=dom.js.map

/**
 * @description
 * @author chenjun
 * @export
 * @param {number} [time=20]
 * @returns {Promise<void>}
 */
function nextMarcoTick(time) {
    if (time === void 0) { time = 20; }
    return new Promise(function (resolve) {
        setTimeout(function () {
            resolve();
        }, time);
    });
}
/**
 * @description
 * @author chenjun
 * @export
 * @param {Function} func
 * @returns {Promise<any>}
 */
function wrapperPromise(func) {
    return new Promise(function (resolve, reject) {
        func(resolve, reject);
    });
}
//# sourceMappingURL=func.js.map

var textAlignEnum = ['left', 'center', 'right', 'vertical'];
//# sourceMappingURL=map.js.map

/**
 * @description
 * @author chenjun
 * @export
 * @class Caption
 * @extends {JsBridge}
 */
var Caption = /** @class */ (function (_super) {
    __extends(Caption, _super);
    function Caption(option) {
        var _this = _super.call(this) || this;
        _this.box = null;
        _this.textEl = null;
        _this.fontFamilyMaps = {};
        _this.uuid = 0;
        _this.coverEl = null;
        _this.strokeEl = [];
        _this.defaultFontSize = 50;
        _this.zIndex = 0;
        _this.el = document.querySelector(option.el) || document.body;
        _this.rendered = false;
        _this.init();
        return _this;
    }
    Caption.prototype.init = function () {
        var _this = this;
        this.register('render', function (attrs) {
            _this.set(attrs);
        });
    };
    Caption.prototype.setTextEl = function (config) {
        this.textEl = createElement('div');
        var textStyle = {
            fontSize: config.font_size,
            lineHeight: config.line_height,
            zIndex: 100,
            fontFamily: config.font_family,
            position: 'relative',
            letterSpacing: config.innerPadding
        };
        if (config.fill_content && config.fill_content.fill_image) {
            textStyle.color = 'transparent';
            textStyle.webkitTextFillColor = 'transparent';
            textStyle.webkitBackgroundClip = 'text';
            textStyle.backgroundImage = "url(" + config.fill_content.fill_image + ")";
            // textStyle.backgroundSize = 'cover';
        }
        if (config.fill_content && config.fill_content.fill_gradients) {
            if (config.fill_content.fill_gradients.type === 1) {
                textStyle.background = "-webkit-linear-gradient(-90deg, " + config.fill_content.fill_gradients.colors[0] + ", " + config.fill_content.fill_gradients.colors[1] + ")";
            }
            else if (config.fill_content.fill_gradients.type === 2) {
                textStyle.background = "-webkit-linear-gradient(0deg, " + config.fill_content.fill_gradients.colors[0] + ", " + config.fill_content.fill_gradients.colors[1] + ")";
            }
            textStyle.color = 'transparent';
            textStyle.webkitTextFillColor = 'transparent';
            textStyle.webkitBackgroundClip = 'text';
        }
        this.textEl.innerHTML = config.text;
        this.box.appendChild(this.textEl);
        this.setTextAlign(textStyle, config.align_type);
        setStyle(this.textEl, textStyle);
        // fixed ios float文字竖排丢失宽度
        if (config.align_type === 3) {
            var width = this.textEl.offsetWidth;
            setStyle(this.el, {
                width: width + config.innerPadding * 2
            });
        }
    };
    /**
     * @description
     * @author chenjun
     * @private
     * @param {AttributeInterface} attrs
     * @returns
     * @memberof Caption
     */
    Caption.prototype.formatConfig = function (attrs) {
        return __awaiter(this, void 0, void 0, function () {
            var config, fontName, _a, width, height, _b, fontSize, lineHeight;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        config = __assign(__assign({}, attrs), { scale: attrs.scale || 1, font_size: typeof attrs.font_size === 'number'
                                ? attrs.font_size
                                : this.defaultFontSize, innerPadding: 0 });
                        config.innerPadding = Math.max(4, attrs.stroke
                            ? attrs.stroke.reduce(function (prev, next) { return prev + next.width; }, 0)
                            : 0, attrs.shadow ? attrs.shadow.intensity / 2 : 0);
                        if (!attrs.type_face_path) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.loadFont(attrs.type_face_path)];
                    case 1:
                        fontName = _c.sent();
                        config.font_family = fontName;
                        _c.label = 2;
                    case 2:
                        if (!(attrs.box && attrs.drawable_background)) return [3 /*break*/, 4];
                        _a = attrs.box, width = _a.width, height = _a.height;
                        return [4 /*yield*/, this.computedSize({
                                // letterSpacing: 
                                innerPadding: config.innerPadding,
                                alignType: config.align_type,
                                fontSize: config.font_size,
                                fontFamily: config.font_family,
                                text: attrs.text,
                                rect: attrs.drawable_background.text_rect
                            }, width - 2 * config.innerPadding, height - 2 * config.innerPadding)];
                    case 3:
                        _b = _c.sent(), fontSize = _b.fontSize, lineHeight = _b.lineHeight;
                        config.font_size = fontSize;
                        config.line_height = lineHeight;
                        config.padding = attrs.drawable_background.text_rect;
                        return [3 /*break*/, 5];
                    case 4:
                        config.line_height = config.font_size + config.innerPadding;
                        _c.label = 5;
                    case 5: 
                    // 图片预加载
                    return [4 /*yield*/, Promise.all([
                            config.fill_content && config.fill_content.fill_image
                                ? config.fill_content.fill_image
                                : '',
                            config.drawable_background
                                ? config.drawable_background.image_path
                                : ''
                        ]
                            .filter(function (path) { return typeof path === 'string' && path !== ''; })
                            .map(function (path) {
                            return _this.loadImage(path);
                        }))];
                    case 6:
                        // 图片预加载
                        _c.sent();
                        return [2 /*return*/, config];
                }
            });
        });
    };
    /**
     * @description
     * @author chenjun
     * @param {string} str 客户端注入json string
     * @memberof Caption
     */
    Caption.prototype.set = function (str) {
        return __awaiter(this, void 0, void 0, function () {
            var attrs, config, _a, baseWidth, i, el;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.clearAttribute();
                        attrs = JSON.parse(str);
                        return [4 /*yield*/, this.formatConfig(attrs)];
                    case 1:
                        config = _b.sent();
                        this.box = document.createElement('div');
                        this.box.classList.add('box');
                        if (config.box) {
                            this.box.classList.add('center');
                            setStyle(this.box, {
                                width: '100%',
                                height: '100%'
                            });
                        }
                        this.box.style.padding = config.innerPadding + 'px';
                        this.el.appendChild(this.box);
                        // 设置文字样式
                        this.setTextEl(config);
                        if (!config.shadow) return [3 /*break*/, 3];
                        _a = this;
                        return [4 /*yield*/, this.makeCover(config)];
                    case 2:
                        _a.coverEl = _b.sent();
                        _b.label = 3;
                    case 3:
                        if (!config.stroke) return [3 /*break*/, 7];
                        baseWidth = 0;
                        i = 0;
                        _b.label = 4;
                    case 4:
                        if (!(i < config.stroke.length)) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.makeStroke(config, i, baseWidth)];
                    case 5:
                        el = _b.sent();
                        this.strokeEl.push(el);
                        baseWidth += 2 * config.stroke[i].width;
                        _b.label = 6;
                    case 6:
                        i++;
                        return [3 /*break*/, 4];
                    case 7:
                        if (!config.text_layer) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.makeLayer(config)];
                    case 8:
                        _b.sent();
                        _b.label = 9;
                    case 9:
                        this.setBoxStyle(config);
                        return [4 /*yield*/, nextMarcoTick(0)];
                    case 10:
                        _b.sent();
                        this.callback();
                        this.rendered = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @description
     * @author chenjun
     * @private
     * @memberof Caption
     */
    Caption.prototype.setBoxStyle = function (config) {
        // 设置盒子部分样式
        var boxStyle = {
            color: this.hexAndAlphaToRgba(config.text_color, config.text_color_alpha),
            transform: "scale(" + config.scale + ")",
            transformOrigin: '0 0 0'
        };
        if (config.padding) {
            boxStyle.padding = config.padding
                .map(function (v) { return v + "px"; })
                .join(' ');
        }
        if (config.fill_background) {
            boxStyle.backgroundColor = this.hexAndAlphaToRgba(config.fill_background.color, config.fill_background.alpha);
        }
        if (config.drawable_background) {
            boxStyle.backgroundImage = "url(" + config.drawable_background.image_path + ")";
        }
        if (config.box && config.drawable_background) {
            boxStyle.width = config.box.width;
            boxStyle.height = config.box.height;
            boxStyle.overflow = 'hidden';
            boxStyle.boxSizing = 'border-box';
            boxStyle.padding = config.drawable_background.text_rect
                .map(function (v) { return v + "px"; })
                .join(' ');
        }
        setStyle(this.el, boxStyle);
    };
    Caption.prototype.getTextElSize = function () {
        var height = this.el.offsetHeight;
        var width = this.el.offsetWidth;
        return {
            width: width,
            height: height
        };
    };
    Caption.prototype.callback = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, width, height, renderData;
            return __generator(this, function (_b) {
                if (this.el) {
                    _a = this.getTextElSize(), width = _a.width, height = _a.height;
                    renderData = {
                        text_size: {
                            width: width,
                            height: height
                        }
                    };
                    this.send(renderData);
                }
                else {
                    this.send({
                        text_size: {
                            width: 0,
                            height: 0
                        }
                    });
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @description
     * @author chenjun
     * @private
     * @param {ConfigInterface} config
     * @param {number} index
     * @param {number} baseWidth
     * @returns
     * @memberof Caption
     */
    Caption.prototype.makeStroke = function (config, index, baseWidth) {
        return __awaiter(this, void 0, void 0, function () {
            var strokeEl, stroke, style;
            return __generator(this, function (_a) {
                strokeEl = document.createElement('div');
                strokeEl.innerHTML = config.text;
                stroke = config.stroke[index];
                style = {
                    letterSpacing: config.innerPadding,
                    position: 'absolute',
                    top: config.innerPadding,
                    left: config.innerPadding,
                    zIndex: 10 + --this.zIndex,
                    color: '#fff',
                    fontFamily: config.font_family,
                    webkitTextStrokeWidth: baseWidth + stroke.width * 2,
                    webkitTextStrokeColor: stroke.color,
                    fontSize: config.font_size,
                    lineHeight: config.line_height
                };
                if (config.align_type === 3) {
                    style.height = '100%';
                }
                else {
                    style.width = '100%';
                }
                if (config.align_type !== 3) {
                    style.width = "calc(100% - " + config.innerPadding * 2 + "px)";
                }
                else {
                    style.height = "calc(100% - " + config.innerPadding * 2 + "px)";
                }
                (this.box || document.body).appendChild(strokeEl);
                this.setTextAlign(style, config.align_type);
                setStyle(strokeEl, style);
                return [2 /*return*/, strokeEl];
            });
        });
    };
    /**
     * @description
     * @author chenjun
     * @private
     * @param {ConfigInterface} config
     * @returns
     * @memberof Caption
     */
    Caption.prototype.makeLayer = function (config) {
        return __awaiter(this, void 0, void 0, function () {
            var cover, layer, strokeWidth, style;
            return __generator(this, function (_a) {
                cover = document.createElement('div');
                cover.innerHTML = config.text;
                layer = config.text_layer;
                strokeWidth = config.stroke
                    ? config.stroke.reduce(function (prev, cur) { return prev + cur.width; }, 0)
                    : 0;
                style = {
                    letterSpacing: config.innerPadding,
                    position: 'absolute',
                    top: config.innerPadding,
                    left: config.innerPadding,
                    zIndex: 2,
                    color: this.hexAndAlphaToRgba(layer.color, layer.alpha),
                    marginLeft: layer.offset_x,
                    marginTop: layer.offset_y,
                    fontFamily: config.font_family,
                    fontSize: config.font_size,
                    lineHeight: config.line_height,
                    webkitTextStrokeWidth: strokeWidth * 2,
                    webkitTextStrokeColor: layer.color
                };
                (this.box || document.body).appendChild(cover);
                if (config.align_type !== 3) {
                    style.width = "calc(100% - " + config.innerPadding * 2 + "px)";
                }
                else {
                    style.height = "calc(100% - " + config.innerPadding * 2 + "px)";
                }
                this.setTextAlign(style, config.align_type);
                setStyle(cover, style);
                return [2 /*return*/, cover];
            });
        });
    };
    /**
     * 在设置气泡和文字渐变时使用
     * background-clip时文字颜色为transparent，textShadow使文字内部存在阴影，其背后需f放置同样大小的白色展位。
     * -webkit-text-stroke为中心描边，约等于外描边 1/2 + 内描边 1/2. 需处理为外描边。
     */
    /**
     * @description
     * @author chenjun
     * @private
     * @param {ConfigInterface} config
     * @returns
     * @memberof Caption
     */
    Caption.prototype.makeCover = function (config) {
        return __awaiter(this, void 0, void 0, function () {
            var cover, shadow, style;
            return __generator(this, function (_a) {
                cover = document.createElement('div');
                cover.innerHTML = config.text;
                shadow = config.shadow;
                style = {
                    letterSpacing: config.innerPadding,
                    textShadow: "-2px -2px " + shadow.intensity + "px " + shadow.color,
                    position: 'absolute',
                    top: config.innerPadding,
                    left: config.innerPadding,
                    zIndex: 1,
                    color: '#fff',
                    fontFamily: config.font_family,
                    fontSize: config.font_size,
                    lineHeight: config.line_height
                };
                (this.box || document.body).appendChild(cover);
                if (config.align_type !== 3) {
                    style.width = "calc(100% - " + config.innerPadding * 2 + "px)";
                }
                else {
                    style.height = "calc(100% - " + config.innerPadding * 2 + "px)";
                }
                this.setTextAlign(style, config.align_type);
                setStyle(cover, style);
                return [2 /*return*/, cover];
            });
        });
    };
    /**
     * @description
     * @author chenjun
     * @private
     * @param {string} fontPath
     * @returns {(string | Promise<string>)}
     * @memberof Caption
     */
    Caption.prototype.loadFont = function (fontPath) {
        var _this = this;
        // 校验字体是否已经加载
        for (var fontName in this.fontFamilyMaps) {
            if (this.fontFamilyMaps[fontName] === fontPath) {
                return fontName;
            }
        }
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var fontName, fontFace, loadedFontFace, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!window.env) return [3 /*break*/, 1];
                        return [3 /*break*/, 4];
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        fontName = 'f-' + ++this.uuid;
                        fontFace = new FontFace(fontName, fontPath);
                        return [4 /*yield*/, fontFace.load()];
                    case 2:
                        loadedFontFace = _a.sent();
                        document.fonts.add(loadedFontFace);
                        this.fontFamilyMaps[fontName] = fontPath;
                        resolve(fontName);
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        console.log(e_1);
                        reject(e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
    };
    /**
     * @description 16进制色值+alpha转rgba
     * @author chenjun
     * @private
     * @param {string} hex
     * @param {number} alpha
     * @returns {string}
     * @memberof Caption
     */
    Caption.prototype.hexAndAlphaToRgba = function (hex, alpha) {
        if (alpha === void 0) { alpha = 100; }
        var str = hex.substr(1);
        if (str.length !== 6 && str.length !== 3) {
            return '';
        }
        if (alpha > 1) {
            alpha /= 100;
        }
        // 处理hex色彩简写
        if (str.length === 3) {
            str = str.repeat(2);
        }
        var tmp = [
            parseInt(str.substr(0, 2), 16),
            parseInt(str.substr(2, 2), 16),
            parseInt(str.substr(4, 2), 16),
            alpha
        ];
        return "rgba(" + tmp.join(',') + ")";
    };
    /**
     * @description 清空样式
     * @author chenjun
     * @memberof Caption
     */
    Caption.prototype.clearAttribute = function () {
        this.zIndex = 0;
        this.strokeEl = [];
        this.el.innerHTML = '';
        this.el.setAttribute('style', '');
    };
    /**
     * @description
     * @author chenjun
     * @param {*} textStyle
     * @param {number} align_type
     * @memberof Caption
     */
    Caption.prototype.setTextAlign = function (textStyle, align_type) {
        var textAlign = textAlignEnum[align_type];
        if (textAlign && textAlign !== 'vertical') {
            textStyle.textAlign = textAlign;
        }
        else if (textAlign) {
            textStyle.writingMode = 'vertical-rl';
        }
    };
    /**
     * @description
     * @author chenjun
     * @private
     * @param {string} src
     * @memberof Caption
     */
    Caption.prototype.loadImage = function (src) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, wrapperPromise(function (resolve, reject) {
                            var img = new Image();
                            img.src = src;
                            img.onload = function () {
                                resolve();
                            };
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @description
     * @author chenjun
     * @param {({
     *             alignType: number;
     *             rect: ConfigInterface['drawable_background']['text_rect'];
     *             fontFamily: string | undefined;
     *             fontSize: number;
     *             text: string;
     *         })} {
     *             fontFamily,
     *             fontSize,
     *             text,
     *             rect,
     *             alignType
     *         }
     * @param {number} maxWidth
     * @param {number} maxHeight
     * @returns
     * @memberof Caption
     */
    Caption.prototype.computedSize = function (_a, maxWidth, maxHeight) {
        var fontFamily = _a.fontFamily, fontSize = _a.fontSize, text = _a.text, rect = _a.rect, alignType = _a.alignType, innerPadding = _a.innerPadding;
        return __awaiter(this, void 0, void 0, function () {
            var box, style;
            return __generator(this, function (_b) {
                box = createElement('div');
                style = {
                    letterSpacing: innerPadding,
                    boxSizing: 'border-box',
                    padding: rect.map(function (val) { return val + "px"; }).join(' '),
                    opacity: 0,
                    lineHeight: fontSize,
                    fontSize: fontSize,
                    fontFamily: fontFamily,
                    overflow: 'hidden'
                };
                if (alignType === 3) {
                    style.height = maxHeight;
                }
                else {
                    style.width = maxWidth;
                }
                this.setTextAlign(style, alignType);
                setStyle(box, style);
                box.innerHTML = text;
                document.body.appendChild(box);
                while (box.offsetHeight > maxHeight ||
                    box.offsetWidth > maxWidth) {
                    fontSize -= 2;
                    if (fontSize < 12) {
                        fontSize = 12;
                        break;
                    }
                    else {
                        setStyle(box, {
                            fontSize: fontSize,
                            lineHeight: fontSize + innerPadding
                        });
                    }
                }
                // document.body.removeChild(box);
                return [2 /*return*/, {
                        fontSize: fontSize,
                        lineHeight: fontSize + innerPadding
                    }];
            });
        });
    };
    return Caption;
}(JsBridge));
//# sourceMappingURL=caption.js.map

// 环境判断
window.env = false;
window.caption = new Caption({ el: "#app" });
window.onerror = function (e) {
    console.log(e);
};
